Attribute VB_Name = "reg_randw"
Option Compare Database

Private Const ERROR_SUCCESS             As LongPtr = 0

Private Const REG_OPTION_NON_VOLATILE   As LongPtr = &H0


Private Type SECURITY_ATTRIBUTES
    nLength              As LongPtr
    lpSecurityDescriptor As LongPtr
    bInheritHandle       As LongPtr
End Type

Private Const KEY_QUERY_VALUE           As LongPtr = &H1   ' TuL[f[^̖₢킹¡
Private Const KEY_ENUMERATE_SUB_KEYS    As LongPtr = &H8   ' TuL[̗񋓂B
Private Const KEY_NOTIFY                As LongPtr = &H10  ' ύX̒ʒm¡
Private Const KEY_CREATE_SUB_KEY        As LongPtr = &H4   ' TuL[̍쐬¡
Private Const KEY_CREATE_LINK           As LongPtr = &H20  ' V{bNN̍쐬¡
Private Const KEY_SET_VALUE             As LongPtr = &H2   ' TuL[f[^̐ݒ¡
Private Const KEY_ALL_ACCESS            As LongPtr = KEY_QUERY_VALUE Or _
                                                  KEY_ENUMERATE_SUB_KEYS Or _
                                                  KEY_NOTIFY Or _
                                                  KEY_CREATE_SUB_KEY Or _
                                                  KEY_CREATE_LINK Or _
                                                  KEY_SET_VALUE
Private Const KEY_READ                  As LongPtr = KEY_QUERY_VALUE Or _
                                                  KEY_ENUMERATE_SUB_KEYS Or _
                                                  KEY_NOTIFY
Private Const KEY_WRITE                 As LongPtr = KEY_SET_VALUE Or _
                                                  KEY_CREATE_SUB_KEY

' w肳ꂽWXgL[쐬BL[łɑ݂Ăꍇ́ÃL[I[vB
Private Declare PtrSafe Function RegCreateKeyEx Lib "advapi32" Alias "RegCreateKeyExA" _
                                (ByVal hKey As LongPtr, _
                                 ByVal lpSubKey As String, _
                                 ByVal reserved As LongPtr, _
                                 ByVal lpClass As String, _
                                 ByVal dwOptions As LongPtr, _
                                 ByVal samDesired As LongPtr, _
                                 lpSecurityAttributes As SECURITY_ATTRIBUTES, _
                                 phkResult As LongPtr, _
                                 lpdwDisposition As LongPtr) As LongPtr
' I[vĂ郌WXgL[̒ltB[hɁAf[^i[B
Private Declare PtrSafe Function RegSetValueEx Lib "advapi32" Alias "RegSetValueExA" _
                                (ByVal hKey As LongPtr, _
                                 ByVal lpValueName As String, _
                                 ByVal reserved As LongPtr, _
                                 ByVal dwType As LongPtr, _
                                 szData As Any, _
                                 ByVal cbData As LongPtr) As LongPtr
' w肳ꂽL[I[vB
Private Declare PtrSafe Function RegOpenKeyEx Lib "advapi32" Alias "RegOpenKeyExA" _
                                (ByVal hKey As LongPtr, _
                                 ByVal lpSubKey As String, _
                                 ByVal ulOptions As LongPtr, _
                                 ByVal samDesired As LongPtr, _
                                 phkResult As LongPtr) As LongPtr

' I[vꂽL[Ɋ֘AtĂw肳ꂽl擾B
Private Declare PtrSafe Function RegQueryValueEx Lib "advapi32" Alias "RegQueryValueExA" _
                                (ByVal hKey As LongPtr, _
                                 ByVal lpValueName As String, _
                                 ByVal lpReserved As LongPtr, _
                                 lpType As LongPtr, _
                                 lpData As Any, _
                                 lpcbData As LongPtr) As LongPtr

' w肳ꂽL[̃nhB
Private Declare PtrSafe Function RegCloseKey Lib "advapi32" _
                                (ByVal hKey As LongPtr) As LongPtr

Public Enum hKeyConstants
    HKEY_CLASSES_ROOT = &H80000000
    HKEY_CURRENT_USER = &H80000001
    HKEY_LOCAL_MACHINE = &H80000002
    HKEY_USERS = &H80000003
    HKEY_PERFORMANCE_DATA = &H80000004
    HKEY_CURRENT_CONFIG = &H80000005
    HKEY_DYN_DATA = &H80000006
End Enum

' DWORD^̃^Cv
Public Enum RegTypeConstants
'    REG_NONE = (0)                         ' `ĂȂ
    REG_SZ = (1)                           ' NULL ŏI镶
'    REG_EXPAND_SZ = (2)                    ' WJO̊ϐւ̎Q  NULL ŏI镶
'    REG_BINARY = (3)                       ' Cӂ̌`̃oCif[^
    REG_DWORD = (4)                        ' 32 rbgl
    REG_DWORD_LITTLE_ENDIAN = (4)          ' gGfBA` 32 rbgl
'    REG_DWORD_BIG_ENDIAN = (5)             ' rbOGfBA` 32 rbgl
'    REG_LINK = (6)                         ' Unicode ̃V{bNN
'    REG_MULTI_SZ = (7)                     ' NULL ŏI镶̔z
'    REG_RESOURCE_LIST = (8)                ' foCXhCõ\[XXg
End Enum
'
' WXg̎w肳ꂽL[ɐlށB
'
Public Function RegSetValue(lnghInKey As hKeyConstants, _
                            ByVal strSubKey As String, _
                            ByVal strValName As String, _
                            lngType As RegTypeConstants, _
                            ByVal varValue As Variant) As Boolean
    ' lnghInKey  : L[
    ' strSubKey  : TuL[
    ' strValName : l
    ' lngType    : f[^^Cv
    ' varValue   : Zbgl
    ' ߂l     : True, sTrue

    Dim lngResult As LongPtr
    Dim lnghSubKey As LongPtr
    Dim SA As SECURITY_ATTRIBUTES
    Dim lngValue As LongPtr
    Dim strValue As String

    ' lB
    RegSetValue = False
    ' L[JVK쐬B
    lngResult = RegCreateKeyEx(lnghInKey, _
                               strSubKey, _
                               0, _
                               "", _
                               REG_OPTION_NON_VOLATILE, _
                               KEY_ALL_ACCESS, _
                               SA, _
                               lnghSubKey, _
                               ByVal 0)
    If lngResult = ERROR_SUCCESS Then
        Select Case lngType
            Case REG_DWORD, REG_DWORD_LITTLE_ENDIAN
                lngValue = CLng(varValue)
                lngResult = RegSetValueEx(lnghSubKey, _
                                          strValName, _
                                          0, _
                                          REG_DWORD, _
                                          lngValue, _
                                          Len(lngValue))
                ' SetValue ɌʂԂB
                RegSetValue = (lngResult = ERROR_SUCCESS)
            Case REG_SZ
                strValue = CStr(varValue)
                lngResult = RegSetValueEx(lnghSubKey, _
                                          strValName, _
                                          0, _
                                          REG_SZ, _
                                          ByVal strValue, _
                                          CLng(LenB(StrConv(strValue, vbFromUnicode)) + 1))
                ' SetValue ɌʂԂB
                RegSetValue = (lngResult = ERROR_SUCCESS)
        End Select
        ' L[N[YB
        Call RegCloseKey(lnghSubKey)
    End If
    
    'TvR[h
    'Debug.Print RegSetValue(HKEY_CURRENT_USER, _
    '                        "Software\HEROPA\RegTest", _
    '                        "FontName", _
    '                        REG_SZ, _
    '                        "lr o")
    'Debug.Print RegSetValue(HKEY_CURRENT_USER, _
    '                        "Software\HEROPA\RegTest", _
    '                        "FontSize", _
    '                        REG_DWORD, _

End Function
'
' WXg̎w肳ꂽL[̒lǂݎB
'
Public Function RegGetValue(lnghInKey As hKeyConstants, _
                            ByVal strSubKey As String, _
                            ByVal strValName As String, _
                            lngType As RegTypeConstants, _
                            ByVal varDefault As Variant) As Variant
    ' lnghInKey  : L[
    ' strSubKey  : TuL[
    ' strValName : l
    ' lngType    : f[^^Cv
    ' varDefault : ftHg̒l
    ' ߂l     : Ήl
    Dim varRetVal           As Variant
    Dim lnghSubKey          As LongPtr
    Dim lngBuffer           As LongPtr
    Dim strBuffer           As String
    Dim lngResult           As LongPtr

    ' ftHg̒lB
    varRetVal = varDefault
    ' WXg̎w肵L[I[vB
    lngResult = RegOpenKeyEx(lnghInKey, _
                             strSubKey, _
                             0, _
                             KEY_ALL_ACCESS, _
                             lnghSubKey)
    If lngResult = ERROR_SUCCESS Then
        Select Case lngType
            Case REG_DWORD, REG_DWORD_LITTLE_ENDIAN
                ' lĂB
                lngBuffer = 0
                lngResult = RegQueryValueEx(lnghSubKey, _
                                            strValName, _
                                            0, _
                                            REG_DWORD, _
                                            lngBuffer, _
                                            Len(lngBuffer))
                If lngResult = ERROR_SUCCESS Then
                    varRetVal = lngBuffer
                End If
            Case REG_SZ
                ' obt@mۂB
                strBuffer = String(256, vbNullChar)
                lngResult = RegQueryValueEx(lnghSubKey, _
                                            strValName, _
                                            0, _
                                            REG_SZ, _
                                            ByVal strBuffer, _
                                            Len(strBuffer))

                If lngResult = ERROR_SUCCESS Then
                    varRetVal = Left$(strBuffer, InStr(strBuffer, vbNullChar) - 1)
                End If
        End Select
        lngResult = RegCloseKey(lnghSubKey)
    End If
    RegGetValue = varRetVal
    
    'TvR[h
    'Debug.Print RegGetValue(HKEY_CURRENT_USER, _
    '                        "Software\HEROPA\RegTest", _
    '                        "FontName", _
    '                        REG_SZ, _
    '                        "")
    'Debug.Print RegGetValue(HKEY_CURRENT_USER, _
    '                        "Software\HEROPA\RegTest", _
    '                        "FontSize", _
    '                        REG_DWORD, _
    '                        0)

End Function

